#include "randomPlayer.h"
#include <time.h>

static const int checkNum = 8;
static const int lines[checkNum][3] = 
{
   {0, 1, 2}, {3, 4, 5}, {6, 7, 8},
   {0, 3, 6}, {1, 4, 7}, {2, 5, 8},
   {0, 4, 8}, {2, 4, 6}
};

RandomPlayer::RandomPlayer()
{

   srand((unsigned)time( NULL ));
}

RandomPlayer::~RandomPlayer()
{

}

void RandomPlayer::generateRetStr(int num1, string &ret)
{
   char buf[10];
   sprintf(buf, "%d,%d", num1/3+1, num1%3+1);
   ret = buf;
}

bool RandomPlayer::isThreaten(string state, int num1, int num2, int num3, string &ret, bool checkX)
{
   char target = 'o';
   if(checkX == true)
      target = 'x';
   char buf[10];
   if(state[num1] == '_' && state[num2] == target && state[num3] == target)
   {
      generateRetStr(num1, ret);
      return true;
   }
   if(state[num1] == target && state[num2] == '_' && state[num3] == target)
   {
      generateRetStr(num2, ret);
      return true;
   }
   if(state[num1] == target && state[num2] == target && state[num3] == '_')
   {
      generateRetStr(num3, ret);
      return true;
   }
   return false;
}

bool RandomPlayer::isOpponentThreaten(string state, string & ret, bool checkX)
{
   for(int i = 0; i < checkNum; i++)
   {
      if(isThreaten(state, lines[i][0], lines[i][1], lines[i][2], ret, checkX) == true)
	 return true;
   }
   return false;
}

bool RandomPlayer::isNearSuccess(string state, string &ret)
{
   if(isOpponentThreaten(state, ret, true) == true)
      return true;
   return false;
}

string RandomPlayer::sense(string state, double reward)
{
   string ret;
   if(isNearSuccess(state, ret) == true)
      return ret;
   if(isOpponentThreaten(state, ret) == true)
      return ret;
   generateNextRandomStep(state, ret);
   return ret;
}

void RandomPlayer::generateNextRandomStep(string state, string &ret)
{
   int num = 0; 
   for(int i = 0; i < 9; i ++)
   {
      if(state[i] == '_')
	 num++;
   }
   int randomVal = rand() % num;
   for(int i = 0; i < 9; i ++)
   {
      if(state[i] == '_')
      {
	 if(randomVal == 0)
	 {
	    generateRetStr(i, ret);
	    return;
	 }
	 randomVal--;
      }
   }
}

void RandomPlayer::terminate(string state, double reward, bool writeLearningData)
{
   return;
}

